INCLUDE (FindPackageHandleStandardArgs)

find_package(PkgConfig QUIET)

pkg_check_modules(PC_MAGIC QUIET libmagic)

FIND_PATH(MAGIC_INCLUDE_DIR magic.h
    HINTS ${PC_MAGIC_INCLUDEDIR} ${PC_MAGIC_INCLUDE_DIRS})
FIND_LIBRARY(MAGIC_LIBRARIES NAMES magic
    HINTS ${PC_MAGIC_LIBDIR} ${PC_MAGIC_LIBRARY_DIRS})

# handle the QUIETLY and REQUIRED arguments and set MAGIC_FOUND to TRUE
find_package_handle_standard_args(MAGIC DEFAULT_MSG MAGIC_LIBRARIES)

if (MAGIC_FOUND)
    set (MAGIC_LIBRARIES ${MAGIC_LIBRARY} ${PC_MAGIC_LIBRARIES})
    set (MAGIC_INCLUDE_DIRS ${MAGIC_INCLUDE_DIR} )
endif ()

MARK_AS_ADVANCED(
    MAGIC_LIBRARIES
    MAGIC_INCLUDE_DIRS )
